<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "analytics_event".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "AnalyticsEvent".
 *
 * Columns in table "analytics_event" available as properties of the model,
 * followed by relations of table "analytics_event" available as properties of the model.
 *
 * @property integer $id
 * @property string $twilio_number_id
 * @property string $source_ip
 * @property string $screen_width
 * @property string $screen_height
 * @property string $viewport_width
 * @property string $viewport_height
 * @property string $date_added
 * @property string $user_id
 * @property string $campaign_source
 * @property string $campaign_medium
 * @property string $campaign_keyword
 * @property string $campaign_content
 * @property string $campaign_name
 * @property string $campaign_id
 * @property string $url
 * @property string $user_agent
 * @property string $gclid
 * @property string $dclid
 * @property string $referer
 *
 * @property TwilioNumber $twilioNumber
 */
class BaseAnalyticsEvent extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'analytics_event';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'AnalyticsEvent|AnalyticsEvents', $n);
    }

    public static function representingColumn()
    {
        return 'source_ip';
    }

    public function rules()
    {
        return array(
            array('twilio_number_id', 'required'),
            array('twilio_number_id', 'length', 'max' => 11),
            array('source_ip', 'length', 'max' => 15),
            array('screen_width, screen_height, viewport_width, viewport_height', 'length', 'max' => 7),
            array('user_id, campaign_source, campaign_medium, campaign_keyword, campaign_content, campaign_name, '
                . 'campaign_id', 'length', 'max' => 63),
            array('url, user_agent, gclid, dclid', 'length', 'max' => 255),
            array('referer', 'length', 'max' => 2047),
            array('date_added', 'safe'),
            array('source_ip, screen_width, screen_height, viewport_width, viewport_height, date_added, user_id, '
                . 'campaign_source, campaign_medium, campaign_keyword, campaign_content, campaign_name, campaign_id, '
                . 'url, user_agent, gclid, dclid, referer', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, twilio_number_id, source_ip, screen_width, screen_height, viewport_width, viewport_height, '
                . 'date_added, user_id, campaign_source, campaign_medium, campaign_keyword, campaign_content, '
                . 'campaign_name, campaign_id, url, user_agent, gclid, dclid, referer', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'twilioNumber' => array(self::BELONGS_TO, 'TwilioNumber', 'twilio_number_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'twilio_number_id' => null,
            'source_ip' => Yii::t('app', 'Source Ip'),
            'screen_width' => Yii::t('app', 'Screen Width'),
            'screen_height' => Yii::t('app', 'Screen Height'),
            'viewport_width' => Yii::t('app', 'Viewport Width'),
            'viewport_height' => Yii::t('app', 'Viewport Height'),
            'date_added' => Yii::t('app', 'Date Added'),
            'user_id' => Yii::t('app', 'User'),
            'campaign_source' => Yii::t('app', 'Campaign Source'),
            'campaign_medium' => Yii::t('app', 'Campaign Medium'),
            'campaign_keyword' => Yii::t('app', 'Campaign Keyword'),
            'campaign_content' => Yii::t('app', 'Campaign Content'),
            'campaign_name' => Yii::t('app', 'Campaign Name'),
            'campaign_id' => Yii::t('app', 'Campaign'),
            'url' => Yii::t('app', 'Url'),
            'user_agent' => Yii::t('app', 'User Agent'),
            'gclid' => Yii::t('app', 'Gclid'),
            'dclid' => Yii::t('app', 'Dclid'),
            'referer' => Yii::t('app', 'Referer'),
            'twilioNumber' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('twilio_number_id', $this->twilio_number_id, true);
        $criteria->compare('source_ip', $this->source_ip, true);
        $criteria->compare('screen_width', $this->screen_width, true);
        $criteria->compare('screen_height', $this->screen_height, true);
        $criteria->compare('viewport_width', $this->viewport_width, true);
        $criteria->compare('viewport_height', $this->viewport_height, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('user_id', $this->user_id, true);
        $criteria->compare('campaign_source', $this->campaign_source, true);
        $criteria->compare('campaign_medium', $this->campaign_medium, true);
        $criteria->compare('campaign_keyword', $this->campaign_keyword, true);
        $criteria->compare('campaign_content', $this->campaign_content, true);
        $criteria->compare('campaign_name', $this->campaign_name, true);
        $criteria->compare('campaign_id', $this->campaign_id, true);
        $criteria->compare('url', $this->url, true);
        $criteria->compare('user_agent', $this->user_agent, true);
        $criteria->compare('gclid', $this->gclid, true);
        $criteria->compare('dclid', $this->dclid, true);
        $criteria->compare('referer', $this->referer, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
